--<< DBA >> View / DBA
-- HUSK at f Oracle Guest password, s jeg kan komme p nettet


--1  -db config / init param
--                   svarer til v$parameters
-- EXAMPLE ndr db_create_file_dest til c:\oradata   (var E:\app\ijo\oradata)
-- mappe-eksistens tjekkes
-- scope = memory  / spfile mulighed prsenteres ved Commit

--2  -db config /  current database properties
--                    svarer til select * from database_properties
-- NLS-tingene
--DEFAULT_PERMANENT_TABLESPACE
--DEFAULT_TEMP_TABLESPACE

--3- View Database Feature usage
                        --svarer til   select * from DBA_FEATURE_USAGE_STATISTICS;
-- Licensing
-- Feature Availability by Edition i http://docs.oracle.com/database/121/DBLIC/editions.htm#DBLIC116

-- Partitioning   SYSTEM vs. USER  (147+8)

--4- Automatic UNDO Management
--   Undo Advisor Finding 1: Undo-tabelomrdet er OK


--5- Database Status Status

--6- Storage , 
--7-   logs, 
--8-   controlfile, 
--9-   redologs, 
--10- tablespaces
-- tablespace CREATE WIZZARD
-- tablespace udvid, klik ts, Action menu, add datafile
--                             Action change storage management
--                           gl - dictionary managed
--                           ny - local m.
--begin
-- dbms_space_admin.tablespace_migrate_from_local(tablespace_name=>'USERS'); 
--end;

-- drop ts Action menu

--11 -  Datafiles
-- udvid en fil

--12- Security - Users
-- lav hugo


-- 13- audit
--Privilege	    User	Proxy	Success	    Failure
--CREATE TABLE	HUGO		    BY ACCESS	BY ACCESS

create table hubert.hugtest2
(nr number)
tablespace system;
insert into hubert.hugtest values (9);
commit;
select * from dba_tables where owner ='HUBERT';

-- select * from dba_audit_trail; -- driller; det er nu den NYE UNIFIED !!
-- kan vre queued, s man m lige skrive dem til disk --EXEC SYS.DBMS_AUDIT_MGMT.FLUSH_UNIFIED_AUDIT_TRAIL;

select 
--*
event_timestamp,sql_text,target_user
from unified_audit_trail order by event_timestamp desc;


-- 14- Performance addm
--vis ADDM
-- vis  AWR Report Viewer

--eks. p DRLIG sql:
select a.* from hr.employees a, hr.employees b, hr.employees c;
-- kartesisk produkt giver mange rkker:
select 107*107*107 from dual; --1225043 rk


-- 15 **************** Scheduler, Your Jobs
   -- PRIVs
     --grant execute on dbms_scheduler to HR;
     --grant scheduler_admin to HR; -- dog ikke ndvendig her
     --grant create job to HR;
     
   -- lav stored procedure MITJOB
   -- lav job
   -- start job (=enable)
   
drop table log_tabellen;
create table log_tabellen (bruger varchar2(30), dato date, tekst varchar2(80));

select * from log_tabellen;

create or replace procedure mitjob
is
begin
--...
--...
INSERT INTO log_tabellen VALUES ('HR',sysdate, 'mit job er krt igen');
end mitjob;
/

exec dbms_scheduler.create_job('HR.myjob', 'STORED_PROCEDURE', 'HR.mitjob', repeat_interval =>'freq=hourly');

select owner, job_name, job_type, job_action, enabled 
from all_scheduler_jobs;   --bemrk IKKE enabled!

exec dbms_scheduler.enable('HR.myjob');

select * from ALL_SCHEDULER_JOB_RUN_DETAILS;
select bruger, to_char(dato, 'ddmmyy hh24:mi'), tekst from hr.log_tabellen;

exec dbms_scheduler.disable('HR.myjob');
   
   
--16 - sql monitor
Tools / Monitor Sessions


--references:
SQL Developer:
https://docs.oracle.com/cd/E12151_01/index.htm

Product manager hos Oracle:
http://www.thatjeffsmith.com/

Oracle By Example:
http://www.oracle.com/technetwork/developer-tools/sql-developer/obe-082749.html


-- export -- mange formater , smart skrivning i SQL'en

select /*csv*/ * from employees; -- HUSK HIGHLIGHT kun denne ---  HUSK EXEC med F5
select /*html*/ * from employees;
select /*insert*/ * from employees;
select /*inger*/ * from employees;  -- fejl ignoreres og der exekveres normalt

-- Zebra striber for lsbarhed
 Tools/Prefs/Db/Util/Worksheet/Grid in CheckerBord or Zebra Pattern
 

